program testlinux3;

uses linux;

var uid,gid : longint;
    f : text;

procedure checkerror;

begin
  if linuxerror<>0 then
     begin
     writeln (stderr,'Linuxerror = ',linuxerror);
     flush (stderr)
     end
end;

begin
  writeln ('Test linux unit - part 16');
  writeln;
  writeln ('Writing small testfile. (test.fil)');
  assign (f,'test.fil');
  rewrite (f);
  writeln (f,'#!/bin/sh');
  writeln (f,'echo $*');
  writeln (f);
  close (f);
  writeln ('doing a chmod 755 (octal)');
  chmod ('test.fil',493);
  writeln ('Hard linking ''test.fil.h'' to ''test.fil'' ');
  link ('test.fil','test.fil.h');
  writeln ('Soft linking ''test.fil.s'' to ''test.fil'' ');
  symlink ('test.fil','test.fil.s');
  writeln ('Directory listing : ');
  shell ('ls -li test.fil*');
  write ('User has ');
  if not Access ('test.fil',(R_OK and W_OK and X_OK)) then write ('NO ');
  writeln('RWX access on ''test.fil'' ');
  write ('Enter an existing UID : ');
  readln (uid);
  write ('Enter an existing GUD : ');
  readln (gid);
  writeln ('Doing a chown (',uid,',',gid,') of ''test.fil''. ');
  chown ('test.fil',uid,gid);
  if linuxerror=sys_eperm then writeln ('Permission denied to do a chown !');
  writeln ('Directory listing : ');
  shell ('ls -li test.fil*');
  write ('User has ');
  if not Access ('test.fil',(R_OK and W_OK and X_OK)) then write ('NO ');
  writeln('RWX access on ''test.fil'' ');
  writeln ('Removing all files.');  
  shell ('rm -f test.fil*')
end.