program linuxtest;

uses linux;

var pid : longint;

procedure catch (sig : integer);

var f : text;

begin
  signal (SIGHUP,pointer(SIG_IGN));
  writeln ('Child : Catch : Caught a signal : ',sig);
  halt (1);
end;

begin
  writeln ('Test Linux unit - part 19');
  writeln;
  write ('Forking off a child. Pid=');
  pid:=fork;
  if pid>0 then
     begin
     { Parent }
     writeln (pid);
     writeln;
     writeln ('Parent : Press <enter> to send a SIGHUP signal to the child');
     readln;
     kill (pid,SIGHUP);
     writeln ('Parent : Child should have caught the signal.');
     writeln ('Press <enter> to terminate');
     readln;
     end
  else
     begin
     { Child }
     { This one catches the signal. }
     Write ('Child: Trying to install SIGHUP handler :');
     if signal (SIGHUP,psignalhandler(@catch))<>pointer(SIG_DFL) then
        begin
        writeln (' Failed.');
        halt
        end;
     Writeln (' OK.');
     { And waits forever...}
     repeat
     until false
     end
end.
