program test5;

uses linux;

type
  TextBuf = array[0..127] of char;


  TextRec = record
    handle : word;
    mode : word;
    bufSize : word;
    _private : word;
    bufpos : word;
    bufend : word;
    bufptr : ^textbuf;
    openfunc : pointer;
    inoutfunc : pointer;
    flushfunc : pointer;
    closefunc : pointer;
    userdata : array[1..16] of byte;
    name : array[0..255] of char;
    buffer : textbuf;
    End;


var pid : longint;
    pipi,pipo : text;
    dummy : string[255];

procedure childproc;

var dummy : string;
    f2 : text;
begin
  assign (f2,'child.out');
  rewrite (f2);
  writeln (f2,'This is the child speaking ! ');
  writeln (f2,'Resetting pipe');
  reset (pipi);
  
  writeln (f2,'Reading from pipe');
  repeat
    begin
    readln (pipi,dummy);
    writeln (f2,'Read : ',dummy)
    end;
  until dummy='stop';
  Writeln (f2,'Stopped reading.');
  close (pipi);
  writeln (f2,'Closed pipe');
  close (f2);
end;


procedure parentproc;

var i : integer;

begin
  writeln ('This is the parent speaking : Child''s pid = ',pid);
  writeln ('Rewriting Pipe');
  rewrite (pipo);
  writeln ('Writing 20 sentences to pipe.');
  for i:=1 to 20 do
      begin
      writeln (pipo,'Line nr. : ',i);
      flush(pipo)
     end;
  writeln (pipo,'stop');
  writeln ('Wrote lines.');
  close (pipo);
  writeln ('Closed pipe');
  writeln;
  writeln ('Child will have written it''s output to ''child.out'' file.')
end;

    
begin
  Writeln ('Testing Linux unit : Pipes.');
  writeln ('Assigning pipes.');
  assignpipe (pipi,pipo);
  if linuxerror<>0 then 
     begin
     writeln ('Couldn''t assign a pipe !');
     halt (1)
     end;
  pid:=fork;
  if pid<0 then
     writeln ('Fork failed with errno : ',linuxerror)
  else
    if pid=0 then
       childproc
    else
       parentproc

end.