program testlinux;

uses linux;
    
var s : string; 
    info : statfs;
    
begin
  writeln ('Test linux unit - part 18');
  writeln;
  writeln ('This program tests the STATFS call.');
  writeln ('Info about current partition : ');
  s:='.';
  while s<>'q' do 
    begin
    fsstat (s,info);
    if linuxerror<>0 then 
       begin
       writeln('Fstat failed. Errno : ',linuxerror);
       halt (1);
       end;
    writeln;
    writeln ('Result of fsstat on file ''',s,'''.');
    writeln ('fstype  : ',info.fstype);
    writeln ('bsize   : ',info.bsize);
    writeln ('bfree   : ',info.bfree);
    writeln ('bavail  : ',info.bavail);
    writeln ('files   : ',info.files);
    writeln ('ffree   : ',info.ffree);
    writeln ('fsid    : ',info.fsid);
    writeln ('Namelen : ',info.namelen);
    write ('Type name of file to do fsstat. (q quits) :');
    readln (s)
    end;
end.